commit 1f9ad6e06a42111bd4b872e0003709dd1dad099d
Author: freddy77 <freddy77>
Date:   Sun Nov 29 18:56:47 2009 +0000

    Fix row number return for cursors

diff --git a/ChangeLog b/ChangeLog
index 6c79f91..1b19737 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Sun Nov 29 19:56:38 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c: Fix row number return for cursors
+
 Fri Nov 27 19:01:33 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc_util.c src/odbc/unittests/describecol.in:
 	- Fix SQL_GUID length
@@ -1926,4 +1929,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2891 2009/11/27 18:01:48 freddy77 Exp $
+$Id: ChangeLog,v 1.2892 2009/11/29 18:56:47 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 708416e..51f2693 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.516 2009/11/27 16:16:39 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.517 2009/11/29 18:56:47 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -3017,6 +3017,7 @@ odbc_cursor_execute(TDS_STMT * stmt)
 	/* set cursor name for TDS7+ */
 	if (ret == TDS_SUCCEED && IS_TDS7_PLUS(tds) && !tds_dstr_isempty(&stmt->cursor_name)) {
 		ret = tds_process_simple_query(tds);
+		stmt->row_count = tds->rows_affected;
 		stmt->dbc->current_statement = NULL;
 		if (ret == TDS_SUCCEED && cursor->cursor_id != 0) {
 			ret = tds_cursor_setname(tds, cursor);
@@ -3068,6 +3069,8 @@ _SQLExecute(TDS_STMT * stmt)
 	stmt->curr_param_row = 0;
 	stmt->num_param_rows = ODBC_MAX(1, stmt->apd->header.sql_desc_array_size);
 
+	stmt->row_count = TDS_NO_COUNT;
+
 	if (stmt->prepared_query_is_rpc) {
 		/* TODO support stmt->apd->header.sql_desc_array_size for RPC */
 		/* get rpc name */
@@ -3148,6 +3151,7 @@ _SQLExecute(TDS_STMT * stmt)
 				ODBC_RETURN(stmt, SQL_ERROR);
 			}
 		}
+		stmt->row_count = TDS_NO_COUNT;
 		if (stmt->num_param_rows <= 1) {
 			dyn = stmt->dyn;
 			tds_free_input_params(dyn);
@@ -3185,7 +3189,6 @@ _SQLExecute(TDS_STMT * stmt)
 	if (!odbc_lock_statement(stmt))
 		ODBC_RETURN_(stmt);
 
-	stmt->row_count = TDS_NO_COUNT;
 	stmt->row_status = PRE_NORMAL_ROW;
 
 	stmt->curr_param_row = 0;

